﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace ThreadExample
{
    // Create a handler for the event. Basically this is just
    // the format that the function which handles the even should follow.
    // you can add whatever parameters you want here but this is 
    // the standard for windows form development.
    public delegate void PopulateNamesCompleteEventHandler(Object sender, PopulateNamesCompleteEventArgs e);

    // Create a wrapper class to pass as a parameter. This allows us to 
    // pass multiple variables back to the main thread. So if you needed
    // an xml document and maybe an error code you could pass both back.
    public class PopulateNamesCompleteEventArgs : EventArgs
    {
        private PopulateNamesCompleteEventArgs() { }
        public PopulateNamesCompleteEventArgs(XmlDocument xml)
        {
            Xml = xml;
        }

        // Expose the XmlDocument we're passing as an argument
        public XmlDocument Xml { get; set; }
    }
}
