﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Threading;

namespace ThreadExample
{
    // This could be an class. Just needed a class that this event
    // belongs to. You could also use Form1 or whatever you have. I
    // just prefer to do this for organizational purposes
    public class Names
    {
        // Create an event using the handler we made in the Events.cs 
        public event PopulateNamesCompleteEventHandler PopulateNamesComplete;

        public void LoadNames()
        {
            // Start the thread
            Thread myThread = new Thread(new ThreadStart(StartLoadNames));
            myThread.Start();
        }

        // This is the entry point for the thread we use to load the names
        private void StartLoadNames()
        {
            XmlDocument xml = new XmlDocument();

            // You can load the xml document from a url here instead. I just did this cause its simple.
            xml.LoadXml("<names><name>Brian</name><name>Jerry</name><name>Andrew</name></names>");

            // Fire the event.
            OnPopulateNamesComplete(new PopulateNamesCompleteEventArgs(xml));
        }

        // This is what we call when we're ready to fire the event
        // Any function that is listening for this event will get run
        // when we run this function.
        private void OnPopulateNamesComplete(PopulateNamesCompleteEventArgs e)
        {
            if (PopulateNamesComplete != null)
                PopulateNamesComplete(this, e);
        }
    }
}
